%if 0%{?fedora}
%bcond_with bosh
%bcond_with minidns
%endif
Name:          smack
Version:       4.0.6
Release:       1%{?dist}
Summary:       Open Source XMPP (Jabber) client library
License:       ASL 2.0
URL:           http://www.igniterealtime.org/projects/smack/index.jsp
Source0:       https://github.com/igniterealtime/Smack/archive/%{version}.tar.gz
Source1:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-core/%{version}/smack-core-%{version}.pom
Source2:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-compression-jzlib/%{version}/smack-compression-jzlib-%{version}.pom
Source3:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-debug/%{version}/smack-debug-%{version}.pom
Source4:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-experimental/%{version}/smack-experimental-%{version}.pom
Source5:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-extensions/%{version}/smack-extensions-%{version}.pom
Source6:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-legacy/%{version}/smack-legacy-%{version}.pom
Source7:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-resolver-dnsjava/%{version}/smack-resolver-dnsjava-%{version}.pom
Source8:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-resolver-javax/%{version}/smack-resolver-javax-%{version}.pom
Source9:       http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-tcp/%{version}/smack-tcp-%{version}.pom
Source10:      http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-bosh/%{version}/smack-bosh-%{version}.pom
Source11:      http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-resolver-minidns/%{version}/smack-resolver-minidns-%{version}.pom

# http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-jingle/4.0.6/smack-jingle-4.0.6.pom
# smack-jingle use NON free javax.media:jmf:2.1.1e

# Default use gradle
Source12:      smack-pom.xml

BuildRequires: maven-local
BuildRequires: mvn(com.jamesmurty.utils:java-xmlbuilder)
BuildRequires: mvn(com.jcraft:jzlib)
BuildRequires: mvn(dnsjava:dnsjava)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.mockito:mockito-core)
BuildRequires: mvn(org.powermock:powermock-api-mockito)
BuildRequires: mvn(org.powermock:powermock-module-junit4)
BuildRequires: mvn(org.powermock:powermock-reflect)
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)
BuildRequires: mvn(xmlunit:xmlunit)
BuildRequires: mvn(xpp3:xpp3)

%if %{with bosh}
# https://bugzilla.redhat.com/show_bug.cgi?id=1177442
BuildRequires: mvn(org.igniterealtime.jbosh:jbosh)
%endif

%if %{with minidns}
# https://bugzilla.redhat.com/show_bug.cgi?id=1177451
BuildRequires: mvn(de.measite.minidns:minidns)
# https://bugzilla.redhat.com/show_bug.cgi?id=1177453
BuildRequires: mvn(org.igniterealtime.jxmpp:jxmpp-util-cache)
%endif

BuildArch:     noarch

%description
Smack is an Open Source XMPP (Jabber) client library for instant
messaging and presence. A pure Java library, it can be embedded
into your applications to create anything from a full XMPP client
to simple XMPP integrations such as sending notification messages and
presence-enabling devices.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n Smack-%{version}
# cleanup
find . -name "*.class" -print -delete
find . -name "*.dll" -print -delete
find . -name "*.jar" -print  -delete

# remove prebuilt documentation
rm -rf javadoc/* documentation/*

cp -p %{SOURCE1} %{name}-core/pom.xml
cp -p %{SOURCE2} %{name}-compression-jzlib/pom.xml
cp -p %{SOURCE3} %{name}-debug/pom.xml
cp -p %{SOURCE4} %{name}-experimental/pom.xml
cp -p %{SOURCE5} %{name}-extensions/pom.xml
cp -p %{SOURCE6} %{name}-legacy/pom.xml
cp -p %{SOURCE7} %{name}-resolver-dnsjava/pom.xml
cp -p %{SOURCE8} %{name}-resolver-javax/pom.xml
cp -p %{SOURCE9} %{name}-tcp/pom.xml
cp -p %{SOURCE10} %{name}-bosh/pom.xml
cp -p %{SOURCE11} %{name}-resolver-minidns/pom.xml

cp -p %{SOURCE12} pom.xml
sed -i "s|@VERSION@|%{version}|" pom.xml

# Disabled for now. Unavailable deps
%if %{without bosh}
%pom_disable_module %{name}-bosh
%endif
%if %{without minidns}
%pom_disable_module %{name}-resolver-minidns
%endif

for m in core compression-jzlib debug experimental extensions legacy resolver-dnsjava resolver-javax tcp bosh resolver-minidns; do

%pom_add_plugin org.apache.maven.plugins:maven-jar-plugin %{name}-${m} "
<configuration>
  <archive>
    <manifestFile>\${project.build.outputDirectory}/META-INF/MANIFEST.MF</manifestFile>
    <manifest>
      <addDefaultImplementationEntries>true</addDefaultImplementationEntries>
      <addDefaultSpecificationEntries>true</addDefaultSpecificationEntries>
    </manifest>
  </archive>
</configuration>"

%pom_add_plugin org.apache.felix:maven-bundle-plugin %{name}-${m} "
<extensions>true</extensions>
<configuration>
  <supportedProjectTypes>
    <supportedProjectType>bundle</supportedProjectType>
    <supportedProjectType>jar</supportedProjectType>
  </supportedProjectTypes>
  <instructions>
    <Bundle-Name>\${project.artifactId}</Bundle-Name>
    <Bundle-Version>\${project.version}</Bundle-Version>
  </instructions>
</configuration>
<executions>
  <execution>
    <id>bundle-manifest</id>
    <phase>process-classes</phase>
    <goals>
      <goal>manifest</goal>
    </goals>
  </execution>
</executions>"

%pom_add_plugin org.apache.maven.plugins:maven-compiler-plugin %{name}-${m} "
<configuration>
  <source>1.7</source>
  <target>1.7</target>
</configuration>"

sed -i "s|name>Smack|name>Smack ${m}|" %{name}-${m}/pom.xml

done

# Fix test deps
%pom_add_dep junit:junit::test %{name}-extensions
#%%pom_add_dep org.hamcrest:hamcrest-all::test %%{name}-extensions
%pom_add_dep com.jamesmurty.utils:java-xmlbuilder::test %{name}-extensions
%pom_add_dep org.mockito:mockito-core::test %{name}-extensions
%pom_add_dep org.powermock:powermock-reflect::test %{name}-extensions
# org.powermock:powermock-api-mockito
%pom_add_dep xmlunit:xmlunit::test %{name}-extensions
%pom_add_dep junit:junit::test %{name}-experimental
%pom_add_dep junit:junit::test %{name}-legacy
%pom_add_dep junit:junit::test %{name}-tcp

# package org.jivesoftware.smack.test.util does not exist
rm -r %{name}-extensions/src/test/java/org/jivesoftware/smackx/iqlast/LastActivityTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/ping/PingTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/pubsub/ItemValidationTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/delay/provider/DelayInformationTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/filetransfer/FileTransferNegotiatorTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/jiveproperties/JivePropertiesExtensionTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/privacy/provider/PrivacyProviderTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/pubsub/ConfigureFormTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/iqversion/VersionTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/forward/ForwardedTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/time/packet/TimeTest.java \
 %{name}-extensions/src/test/java/org/jivesoftware/smackx/receipts/DeliveryReceiptTest.java \
 %{name}-experimental/src/test/java/org/jivesoftware/smackx/carbons/CarbonTest.java \
 %{name}-experimental/src/test/java/org/jivesoftware/smackx/hoxt/provider/Base64BinaryChunkProviderTest.java \
 %{name}-experimental/src/test/java/org/jivesoftware/smackx/hoxt/provider/AbstractHttpOverXmppProviderTest.java \
 %{name}-experimental/src/test/java/org/jivesoftware/smackx/hoxt/provider/HttpOverXmppReqProviderTest.java \
 %{name}-experimental/src/test/java/org/jivesoftware/smackx/hoxt/provider/HttpOverXmppRespProviderTest.java
 
# org.junit.ComparisonFailure
rm -r %{name}-extensions/src/test/java/org/jivesoftware/smackx/caps/EntityCapsManagerTest.java

# expected null, but was:<en>
rm -r %{name}-core/src/test/java/org/jivesoftware/smack/util/PacketParserUtilsTest.java

# fix non ASCII chars
for s in %{name}-core/src/main/java/org/jivesoftware/smack/util/dns/HostAddress.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/caps/cache/SimpleDirectoryPersistentCache.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/bytestreams/socks5/Socks5BytestreamManager.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/address/MultipleRecipientManager.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/caps/packet/CapsExtension.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/caps/provider/CapsExtensionProvider.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/caps/EntityCapsManager.java \
 %{name}-extensions/src/main/java/org/jivesoftware/smackx/caps/cache/EntityCapsPersistentCache.java;do
  native2ascii -encoding UTF8 ${s} ${s}
done

%build

%mvn_package :%{name}-parent __noinstall
%mvn_build -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc README.md resources/releasedocs/README.html resources/releasedocs/changelog.html

%files javadoc -f .mfiles-javadoc
%doc resources/releasedocs/README.html resources/releasedocs/changelog.html

%changelog
* Wed Dec 24 2014 gil cattaneo <puntogil@libero.it> 4.0.6-1
- update to 4.0.6

* Thu Dec 04 2014 gil cattaneo <puntogil@libero.it> 4.0.0-1
- update to 4.0.0

* Thu Dec 04 2014 gil cattaneo <puntogil@libero.it> 3.2.2-8
- fix for CVE-2014-0363 (rhbz#1093274)
- remove jzlib systemPath in smackx pom

* Thu Aug 21 2014 gil cattaneo <puntogil@libero.it> 3.2.2-7
- fix for CVE-2014-5075 (rhbz#1127277)

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 3.2.2-5
- Use Requires: java-headless rebuild (#1067528)

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Dec 26 2012 gil cattaneo <puntogil@libero.it> 3.2.2-2
- enabled unit-tests

* Thu Sep 06 2012 gil cattaneo <puntogil@libero.it> 3.2.2-1
- initial rpm
